From: David Paleino <dapal@debian.org>
Subject: handle filedir completion for dlocate, plus some
 overall improvements
Bug-Debian: http://bugs.debian.org/551707

--- /tmp/dlocate-completion.old	2009-12-27 22:37:49.000000000 +0100
+++ dlocate-completion	2009-12-27 22:42:13.000000000 +0100
@@ -6,27 +6,29 @@
 	local cur prev
 
 	COMPREPLY=()
-	cur=${COMP_WORDS[COMP_CWORD]}
+	cur=$(_get_cword)
+	# the following can be substituted with $(_get_pword) on bash-completion >1.1, not yet released
 	prev=${COMP_WORDS[COMP_CWORD-1]}
 
 	case "$prev" in
 	-S)
 		_filedir
-		return 0
 		;;
 	-@(L|l|s|ls|du|conf|lsconf|md5sum|md5check|man))
 		COMPREPLY=( $( _comp_dpkg_installed_packages $cur ) )
-		return 0
 		;;
-	*)
+	esac
+
+	case "$cur" in
+	-*)
 		COMPREPLY=( $( compgen -W '-h -H -V -S -L -l -s -ls -du \
 			-conf -lsconf -md5sum -md5check -man --help \
 			--version' -- $cur ) )
-		return 0
+		;;
+	*)
+		_filedir
 		;;
 	esac
-	
-	# notreached
 	return 0
 }
 complete -F _dlocate $filenames dlocate
